% Before running this, please, run c# version to generate tests.
% metrics to test, this must be synchronized with c# version.
fout = fopen('matlab-results.csv','w');

s = dir('Tests\*.csv');
testCount = size(s,1);
fprintf(fout, 'PCA\n');
fprintf('_____________________________________________________________________\n');
fprintf('| %65s \n', 'PCA');
fprintf('_____________________________________________________________________\n');
fprintf('| Objects  |  Factors | Repeats |   Total   |  Average  |  Single   |\n');
fprintf('|  count   |   count  |  count  |   Time    |  MFLOPS   | Calc Time |\n');
fprintf('_____________________________________________________________________\n');
fprintf(fout,'Objects,Factors,Repeats,Matlab Time,Single calc time\n');

for i=1:testCount
    test = s(i);
    fileName = test.name; 
    temp = sscanf(fileName, '%d.%d.%d.%d');
    o = temp(2);
    f = temp(3);
    r = temp(4);
    op = (o * o * f + o^3) * r;
    X = dlmread(strcat('Tests\', fileName));
    tic;
    for l=1:r
    	[W, Y] = princomp(X);
        clear W;
        clear Y:
    end;
    time = toc;
    p = op / time / 1e+6;
    it = time / r;
    fprintf('| %8d | %8d | %7d |   %7.3f | %9d |    %6.3f |\n', o, f, r, time, ceil(p), it);
    fprintf(fout,'%d,%d,%d,%7.3f,%d,%6.3f\n',o, f, r, time, ceil(p), it);
    fprintf('_____________________________________________________________________\n');
end;

fclose(fout);

ffinmath = fopen('finmath-results.csv','r');
fmatlab = fopen('matlab-results.csv','r');

s = dir('Tests\*.csv');
testCount = size(s,1);
objects = zeros(testCount, 1);
factors = zeros(testCount, 1);
Ftime = zeros(testCount, 1 );
Mtime = zeros(testCount, 1 );

fgets(ffinmath);
fgets(ffinmath);
fgets(fmatlab);
fgets(fmatlab);
for i=1:testCount
    s = fgets(ffinmath);
    t = sscanf(s, '%d,%d,%d,%f,%f,%f\n');
    Ftime(i) = t(6);
    objects(i) = t(1);
    factors(i) = t(2);

    s = fgets(fmatlab);
    t = sscanf(s, '%d,%d,%d,%f,%f,%f\n');
    Mtime(i) = t(6);
end;

cols = unique(objects);
colsCount = length(cols);

figure(1);
for i=1:colsCount
    indices = find(objects == cols(i));
    fff = Ftime(indices);
    mmm = Mtime(indices);
    subplot(1, colsCount, i) , pf = plot(factors(indices), fff);
    set(pf,'Color','blue','LineWidth',1)
    hold all;
    subplot(1, colsCount, i), pm = plot(factors(indices), mmm);
    set(pm,'Color','red','LineWidth',1)
    title(strcat('Correlation  ',int2str(cols(i))));
    xlabel('Factors count');
    ylabel('Time in sec.');
    if (i == 1 && j == 1)
        leg = legend('FinMath','MatLab');
        set(leg,'Location','NorthWest');
    end;
end;

fclose(ffinmath);
fclose(fmatlab);
